﻿namespace ATAS.Indicators.Technical
{
    using System;
    using ATAS.Indicators;
    using Utils.Common.Logging;

    public class Example1_4 : Indicator
    {
        protected override void OnCalculate(int bar, decimal value)
        {
        }

        protected override void OnInitialize()
        {
            int bullishFirst = 0; // Bullish Part
            int bullishSum = 0;
            for (int i = 1; i < CurrentBar; i++) 
            {
                var candle = GetCandle(i);
                var candlePrev = GetCandle(i-1);
                if (candle.Close > candle.Open & candlePrev.Close < candlePrev.Open) 
                {
                    int bullishLine = 1; 
                    if (i + bullishLine < CurrentBar)
                    {                        
                        while (true)
                        {
                            var candleNext = GetCandle(i + bullishLine);
                            if (candleNext.Close > candleNext.Open) bullishLine++;
                                else break;
                            if (i + bullishLine > CurrentBar - 1) break;
                        }
                    }
                    bullishSum += bullishLine;                  
                    bullishFirst++;
                }
            }

            this.LogInfo($"Instrument = {Instrument}");
            this.LogInfo($"Chart Type = {ChartType}");
            this.LogInfo($"Timeframe = {TimeFrame}");
            this.LogInfo($"Total Bullish {bullishFirst}");
            this.LogInfo($"Total Bullish Length {bullishSum}");
            double d1 = Convert.ToDouble(bullishFirst);
            double d2 = Convert.ToDouble(bullishSum);
            this.LogInfo($"Average Bullish Length {d2 / d1}");

            ////

            int bearishFirst = 0; // Bearish Part
            int bearishSum = 0;

            for (int i = 1; i < CurrentBar; i++) 
            {
                var candle = GetCandle(i);
                var candlePrev = GetCandle(i - 1);

                if (candle.Close < candle.Open & candlePrev.Close > candlePrev.Open) 
                {
                    int bearishLine = 1; 

                    if (i + bearishLine < CurrentBar)
                    {

                        while (true)
                        {
                            var candleNext = GetCandle(i + bearishLine);
                            if (candleNext.Close < candleNext.Open) bearishLine++;
                            else break;
                            if (i + bearishLine > CurrentBar - 1) break;
                        }
                    }
                    bearishSum += bearishLine;
                    bearishFirst++;
                }
            }

            

            this.LogInfo($"Total Bearish {bearishFirst}");
            this.LogInfo($"Total Bearish Length {bearishSum}");
            d1 = Convert.ToDouble(bearishFirst);
            d2 = Convert.ToDouble(bearishSum);
            this.LogInfo($"Average Bearish Length {d2 / d1}");



        }
    }
}
